/*
 * AtomSelectorJDialog.java
 *
 * Created on May 21, 2008, 11:15 AM
 */

package pdb_editor.dialogs;

/**
 *
 * @author  Administrator
 */
public class AtomSelectorDialog extends javax.swing.JDialog {
    
    public int Value = CANCELLED;
    
    static final public int CANCELLED = -1;
    static final public int SELECTED_ATOMS = 0;
    static final public int SELECTED_RESIDUES = 1;
    static final public int SELECTED_CHAINS = 2;
    static final public int ALL_ATOMS = 3;
    
    /** Creates new form AtomSelectorJDialog */
    public AtomSelectorDialog(java.awt.Frame parent, boolean modal, String WindowTitle, int DefaultValue) {
        super(parent, modal);
        initComponents();
        this.setTitle(WindowTitle);
        this.buttonGroup.add(this.jRadioButtonAllAtoms);
        this.buttonGroup.add(this.jRadioButtonSelectedAtoms);
        this.buttonGroup.add(this.jRadioButtonSelectedChains);
        this.buttonGroup.add(this.jRadioButtonSelectedResidues);
        this.jRadioButtonSelectedAtoms.setSelected(true);
        switch (DefaultValue)
        {
            case SELECTED_ATOMS : this.jRadioButtonSelectedAtoms.setSelected(true); break;
            case SELECTED_RESIDUES : this.jRadioButtonSelectedResidues.setSelected(true); break; 
            case SELECTED_CHAINS : this.jRadioButtonSelectedChains.setSelected(true); break;
            case ALL_ATOMS : this.jRadioButtonAllAtoms.setSelected(true); break;
        }
    }
    
    private int getValue()
    {
        if (this.jRadioButtonAllAtoms.isSelected()) return ALL_ATOMS;
        if (this.jRadioButtonSelectedAtoms.isSelected()) return SELECTED_ATOMS;
        if (this.jRadioButtonSelectedChains.isSelected()) return SELECTED_CHAINS;
        if (this.jRadioButtonSelectedResidues.isSelected()) return SELECTED_RESIDUES;
        return CANCELLED;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup = new javax.swing.ButtonGroup();
        jRadioButtonSelectedAtoms = new javax.swing.JRadioButton();
        jRadioButtonSelectedResidues = new javax.swing.JRadioButton();
        jRadioButtonSelectedChains = new javax.swing.JRadioButton();
        jRadioButtonAllAtoms = new javax.swing.JRadioButton();
        jButtonOK = new javax.swing.JButton();
        jButtonCancel = new javax.swing.JButton();

        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jRadioButtonSelectedAtoms.setText("Selected Atoms");

        jRadioButtonSelectedResidues.setText("Selected Residues");

        jRadioButtonSelectedChains.setText("Selected Chains");

        jRadioButtonAllAtoms.setText("All Atoms");

        jButtonOK.setText("OK");
        jButtonOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOKActionPerformed(evt);
            }
        });

        jButtonCancel.setText("Cancel");
        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jRadioButtonSelectedAtoms)
                    .addComponent(jRadioButtonSelectedResidues)
                    .addComponent(jRadioButtonSelectedChains)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jRadioButtonAllAtoms)
                                .addGap(36, 36, 36))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jButtonOK, javax.swing.GroupLayout.DEFAULT_SIZE, 99, Short.MAX_VALUE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonCancel, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))
                .addContainerGap(11, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jRadioButtonSelectedAtoms)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jRadioButtonSelectedResidues)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jRadioButtonSelectedChains)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jRadioButtonAllAtoms)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonOK)
                    .addComponent(jButtonCancel))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void jButtonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelActionPerformed
    Value = CANCELLED;
    this.hide();
}//GEN-LAST:event_jButtonCancelActionPerformed

private void jButtonOKActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOKActionPerformed
    Value = getValue();
    this.hide();
}//GEN-LAST:event_jButtonOKActionPerformed

private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing

}//GEN-LAST:event_formWindowClosing

private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
     Value = CANCELLED;
    this.hide();
}//GEN-LAST:event_formWindowClosed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup;
    private javax.swing.JButton jButtonCancel;
    private javax.swing.JButton jButtonOK;
    private javax.swing.JRadioButton jRadioButtonAllAtoms;
    private javax.swing.JRadioButton jRadioButtonSelectedAtoms;
    private javax.swing.JRadioButton jRadioButtonSelectedChains;
    private javax.swing.JRadioButton jRadioButtonSelectedResidues;
    // End of variables declaration//GEN-END:variables

}
